require 'fileutils'
require 'git'
require 'yaml'

class Andy

  ANDY_HOME=ENV['HOME'] + "/.andy"

  def run
  	ensure_local_repo_built
  	siteName = ARGV[0]
  	if (!siteName)
  		puts "Usage: andy <siteName>"
  		return
    end

  	directory_name = Dir::pwd + "/" + siteName
  	if FileTest::directory?(directory_name)
  		puts "That already exists, sorry"
		return
	end
	
	load_config
	pint = ARGV[1] || @conf['conf']['favourite']
    puts "Creating a project from pint '#{pint}'"
    ensure_pint_source_exists pint
    pour_pint pint, directory_name

  end

  def pour_pint(pint, target)

  	pint_src = "#{ANDY_HOME}/pints/#{pint}" 
    FileUtils.cp_r pint_src, target
  
  end

  def ensure_pint_source_exists(pint)
  	 root_of_pint = ANDY_HOME + "/pints/#{pint}"
  	 if ( FileTest::directory?(root_of_pint) ) 
  	   return 
  	 end
 
     pump = @conf['pints'][pint]
     begin
     	Git.export(pump, root_of_pint)
     rescue => e
     	puts "Something went wrong trying to fetch pint '#{pint}' from '#{pump}' #{e}"
     	exit 1
     end
  end

  def load_config
  	  
  	@conf = @conf || YAML.load(File.open(ANDY_HOME + '/andy.yaml'))

  end

  def ensure_local_repo_built
  	if !FileTest::directory?ANDY_HOME
      Dir::mkdir(ANDY_HOME)
  	end
  	
  	$LOAD_PATH.each do | dir | 
  	  if dir =~ /andy.*\/conf$/ 
  	  	FileUtils.cp(dir + "/andy.yaml", ANDY_HOME )
  	  end
  	end
  end

end
