require 'erb'
require 'fileutils'

module Andy
  module Api
  	class Install
      include Thor::Actions

  		def initialize(config)
  			@config = config
  		end

  		def install(pint_name, project_name, dir_name, project_parent_location)
        project_path = File.join(project_parent_location, dir_name)
        FileUtils::mkdir_p(project_path)
        pint = @config.get_pint(pint_name)
        pint.source_files.each do |relative_source_file|
          source_file = File.join(pint.location, relative_source_file)
          destination_file = File.join(project_path, relative_source_file)
          is_template = relative_source_file.end_with?('.erb')
          destination_file = destination_file[0..-5] unless !is_template
          body = File.open(source_file).read
          if ( relative_source_file.end_with?('.erb') ) 
             erb = ERB.new(body)
             body = erb.result(binding)
          end
          destination_dir = Pathname.new(destination_file).dirname
          FileUtils::mkdir_p(destination_dir) unless File.directory?(destination_dir)
          output = File.open(destination_file, 'w')
          output.puts body
          output.close
        end

      end

  	end
  end
end