require 'ostruct'
require 'yaml'
require 'andy/exceptions'
require 'andy/pint'

module Andy
  class Config

  	def initialize(andy_home = ENV['ANDY_HOME'])
  		@home = andy_home
  		@pint_home = "#{@home}/pints"
      @pints = load_pints
  	end

  	def home
  		@home
  	end

  	def pint_home
  		@pint_home
  	end

    def pints 
      @pints.values
    end

    def get_pint(pint_name)
      @pints[pint_name]
    end

    private
    def load_pints
      pints = {}
      Dir.foreach(@pint_home) do |pint_location|
        next if pint_location == '.' or pint_location == '..'
        pint_location = File.join(@pint_home, pint_location)
        begin
          pint = Andy::Pint.new(pint_location)
          pints [pint.name] = pint 
        rescue Exception => e #Andy::UknkownPintException
          #puts "E => #{e}"
          #puts "Failed to load pint from #{pint_location}"
        end
      end
      pints
    end
  end
end