require 'yaml'
require 'andy/nested_ostruct'
require 'fileutils'
require 'pathname'
require 'andy/exceptions'

module Andy
  class Pint
    
  	def initialize(location)
  		@location = location
  		begin
  		  config = YAML.load_file("#{location}/pint.yml")
  		rescue
  		  raise UnknownPintException.new
  		end
        pint_config = Andy::NestedOStruct.new config
        @my_config = pint_config.pint
  	end

  	def name
  		@my_config.name
  	end

  	def long_name
  		@my_config.long_name
  	end

  	def description
  		@my_config.description
  	end

  	def version
  		@my_config.version
  	end

  	def author
  		@my_config.author
  	end

  	def remote
  		@my_config.remote
  	end

    def location
      @location
    end

  	def generated_files
  		my_files = []
  		Dir.glob("#{@location}/**/*").each do |file_name|
  			file = File.new(file_name)
  			if (! File.directory?(file_name))
  			  path_name = Pathname.new(file_name).relative_path_from(Pathname.new(@location)).to_s
  			  generated_file_name = path_name.end_with?('.erb') ? path_name[0..-5] : path_name
  			  my_files << generated_file_name unless generated_file_name == 'pint.yml'
  			end
  		end
  		my_files
  	end

    def source_files
      my_files = []
      Dir.glob("#{@location}/**/*").each do |file_name|
        file = File.new(file_name)
        if (! File.directory?(file_name))
          path_name = Pathname.new(file_name).relative_path_from(Pathname.new(@location)).to_s
          my_files << path_name unless path_name == 'pint.yml'
        end
      end
      my_files
    end

  end
end