require 'thor'
require 'andy/config'
require 'andy/api/list'
require 'andy/api/install_api'
require 'andy/api/fetch_api'

module Andy
  class CLI < Thor

    def initialize(args=[], options={}, config={})
      super(args, options, config)
      @config = Andy::Config.new
      @list = Andy::Api::List.new @config
      @install = Andy::Api::Install.new @config
      @fetch = Andy::Api::Fetch.new
    end
 	
  	desc "new", "Generates an app directory and copies the appropriate files"
    option :pint_name, :required => true, :aliases => ['-p']
    option :app_name, :required => false, :aliases => ['-a']
    def new(dir_name)
      # def install(pint_name, project_name, dir_name, project_parent_location)
      pint_name = options[:pint_name]
      app_name = options[:app_name] || dir_name
      project_parent_location = Dir.getwd
      @install.install(pint_name, app_name, dir_name, project_parent_location)
      puts "Created project #{app_name} in #{dir_name}"
    end

    desc "list", "Lists known pints"
    option :local, :type => :boolean, :aliases => ['-l']
    option :remote, :type => :boolean, :aliases => ['-r']
    def list
    	if options[:local]
        list_local
      end
      if options[:remote]
         list_remote
      end
      if !options[:local] && !options[:remote]
        list_local
        list_remote
      end
    end

    desc "update", "fetches latest official pints"
    def update
      catalog = @fetch.build_pint_catalog
    end

    no_tasks do
      def list_local
        puts "\n"
        local_pints = @list.pint_names
        puts "Installed pints:"
        local_pints.each do |pint|
          puts "  #{pint}"
        end
        puts "\n"
      end

      def list_remote
        catalog = @fetch.build_pint_catalog
        puts "\nRemote pints:"
        catalog.keys.each do |pint|
          puts "  #{pint}"
        end
        puts "\n"
      end
    end

  

  end
end